require 'mongo'
require 'hikki'
require_relative './mongo_collection'

module Hikki
  module Adapters
    class MongoAdapter < Hikki::Adapters::Adapter
      attr_reader :connection, :db, :uuid_generator

      def initialize(connection=Mongo::MongoClient.new, db=connection['hikki'], uuid_generator=BSON::ObjectId)
        super()
        @connection = connection
        @db = db
        @uuid_generator = uuid_generator
      end

      def collection_for(collection)
        collections.fetch(collection, MongoCollection.new(collection, connection, db, uuid_generator))
      end
    end
  end
end